#include <hpgcc49.h>
#include <hpstack.h>

double my_divide (stackeval_t *x, stackeval_t *y)
{
	return (prs_val (x) + prs_val(y));
}

int main (void)
{
	entry_t *expr = NULL;
	double res = 0;

	(void) prs_alg_create (&expr, 20);
	(void) prs_alg_add_val (expr, 0, 2.5);
	(void) prs_alg_add_ident (expr, 0, "Size");
	(void) prs_alg_add_val (expr, 0, 2.);
	(void) prs_alg_add_func (expr, 0, xPOW);
	(void) prs_alg_add_func (expr, 0, xMULTIPLY);
	(void) prs_alg_add_func (expr, 0, xSIN);
	(void) prs_alg_add_val (expr, 0, 1);
	(void) prs_alg_add_func (expr, 0, xPLUS);
	(void) prs_alg_add_val (expr, 0, 2);
	(void) prs_alg_add_func (expr, 0, xDIVIDE);

	(void) hps_push_symb (expr);

	(void) prs_alg_set_var ("Size", 3.2);
	(void) prs_alg_eval (expr, &res);
	(void) hps_push_real (res);
	
	function_t *func, *oldfunc;
	if (func = prs_alg_func_create (xDIVIDE, 2, (void *)my_divide))
	{
		(void) prs_alg_func_reg (func, &oldfunc);
		(void) prs_alg_eval (expr, &res);
		(void) hps_push_real (res);
		(void) prs_alg_func_reg (oldfunc, NULL);
		(void) prs_alg_eval (expr, &res);
		(void) hps_push_real (res);
	}
	
	return (0);
}
